//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  Nbv{[h̊Ď
//  Nbv{[h̃eLXgŎ擾
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2022N1023 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 10 rh 19043 Pro 64 bit + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FNextWindow : HWND;
    procedure WMChangeCBChain(var Message: TWMChangeCBChain); message
      WM_CHANGECBCHAIN;
    procedure WMDrawClipboard(var Message: TWMDrawClipboard); message
      WM_DRAWCLIPBOARD;
  public
    { Public 錾 }
    procedure BringToFrontForm(AHandle: HWND);
  end;

var
  Form1: TForm1;

implementation

uses
  Vcl.Clipbrd;

{$R *.dfm}

//=============================================================================
//  ̃tH[Nbv{[hr[Ƃēo^
//  FNextWindow ͎̃Nbv{[hr[EBhẼnh
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  FNextWindow := SetClipboardViewer(Handle);
end;

//=============================================================================
//  Nbv{[hr[ƂĂ̓o^
//  Nbv{[hĎ̃`FCO
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  ChangeClipboardChain(Handle, FNextWindow);
end;

//=============================================================================
//  Nbv{[hɂ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  Clipboard.Clear;
end;

//=============================================================================
//  擾eNA
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

//=============================================================================
//  EBhENbv{[h`FC폜鎞ɑĂ郁bZ[W
//=============================================================================
procedure TForm1.WMChangeCBChain(var Message: TWMChangeCBChain);
begin
  if (Message.Remove = FNextWindow) then begin
    FNextWindow := Message.Next;
    Message.Result := 0;
  end else begin
    SendMessage(FNextWindow, WM_CHANGECBCHAIN, Message.Remove, Message.Next);
  end;
end;

//=============================================================================
//  Nbv{[hXVtbN
//  Nbv{[h̓eɍXV鎞ɑĂ郁bZ[W
//  CF_TEXT ̎ɃeLXgNbv{[h玩IɎ擾
//
//  {Tvł́CAvNɂ̃bZ[WM
//=============================================================================
procedure TForm1.WMDrawClipboard(var Message: TWMDrawClipboard);
var
  LhClipbrd : THandle;
begin
  // Microsoft Edge, Google Chrome  URL Rs[̑Ή
  // Nbv{[hJȂG[
  try
    ClipBoard.Open;
  except
    Exit;
  end;

  if Clipboard.HasFormat(CF_TEXT) then begin
    LhClipbrd := Clipboard.GetAsHandle(CF_TEXT);
    try
      Memo1.Lines.Add(Clipboard.AsText);
    finally
      GlobalUnlock(LhClipbrd);
    end;
  end;
  Clipboard.Close;

  //̃Nbv{[hr[EBhEɃbZ[W𑗂
  SendMessage(FNextWindow, WM_DRAWCLIPBOARD, 0, 0);

  BringToFrontForm(Handle);
end;

//-----------------------------------------------------------------------------
//  wtH[IɍőOʂɕ\֐
//  ̎葱sEBhEANeBułȂꍇp
//
//  AHandle : Oʂɕ\tH[̃nh (CtH[ȊO)
//  SPI_GETFOREGROUNDLOCKTIMEOUT, SPI_SETFOREGROUNDLOCKTIMEOUT ̓fobN
//-----------------------------------------------------------------------------
procedure TForm1.BringToFrontForm(AHandle: HWND);
var
  LhForeWnd     : HWND;
  LTimeOut      : DWORD;
  LThreadForeID : Cardinal;
  LThreadSelfID : Cardinal;
begin
  // ݂̍őOʂ̃EBhEnh擾
  // ^COȂƃEBhEnh擾łȂƂ
  LhForeWnd := 0;
  while True do begin
    LhForeWnd := GetForegroundWindow;
    if LhForeWnd <> 0 then Break;
    Application.ProcessMessages;
    Sleep(10);
  end;
  // ݂̍őOʃEBhẼvZXID̒l擾
  LThreadForeID := GetWindowThreadProcessId(LhForeWnd);
  // Oʕ\EBhẼvZX̃XbhID̒l擾
  // LThreadSelfID := GetWindowThreadProcessId(AHandle); łOK (l͈Ⴄ)
  LThreadSelfID := GetCurrentThreadId;
  try
    // Xbh̃A^b`
    AttachThreadInput(LThreadSelfID, LThreadForeID, True);
    // ^XNo[̓_ŎԂ̐ݒl擾 (tHAOhɂ܂ł̎)
    // ftHgl͔ɑ傫Ȓl.ʏ͑Oʂɕ\Ȃœ_ł邾
    SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, @LTimeOut, 0);

    // ^XNo[̓_ŎԂ̐ݒ
    // _ŎԂ 0 ɂĒɍőOʂɕ\悤ɂ
    SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, nil, 0);

    // ŏĂƂ͌ɖ߂
    if IsIconic(AHandle) then begin
      SendMessage(AHandle, WM_SYSCOMMAND, SC_RESTORE, 0);
    end;
    // őOʂɕ\
    SetForegroundWindow(AHandle);
  finally
    // ^XNo[̓_ŎԂ̐ݒɖ߂
    SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, Pointer(LTimeOut), 0);
    // IA^b`؂藣
    AttachThreadInput(LThreadSelfID, LThreadForeID, False);
  end;
end;

end.
